///    ,      
///Version: 0.1   Author: Xakep

unit Stack;

type
  ///   
  TType = integer;
  ///     
  PNode = ^TNode;
  ///   
  TNode = record
    Data: TType;
    Next: PNode;
  end;    

//----------------------------------------------
////  ,     
//----------------------------------------------

///    
///P - , Data - 
procedure AddNode(var P: PNode; Data: TType);
var
  P1: PNode;
begin
  New(P1);
  P1^.Data := Data; 
  P1^.Next := P;
  P := P1;
end;

///    
procedure DelNode(var P: PNode);
var
  P1: PNode;
begin
  P1 := P; P := P^.Next;
  Dispose(P1);
end;
///    
///P - , tmp - 
procedure DelNode(var P: PNode; tmp: PNode);
var
  tmpi: PNode;
begin
  //       ,  
  if (P = nil) or (tmp = nil) then exit;
  
  // tmp -    
  if tmp = P then 
  begin
    P := tmp^.Next; 
    Dispose(tmp);
  end
  else
  begin
    tmpi := P;
    
    //    "" ,    
    while (tmpi^.Next <> nil) do
      if tmpi^.Next = tmp then
      begin
        //       
        tmpi^.Next := tmp^.Next;
        Dispose(tmp);
      end
      else tmpi := tmpi^.Next;    
  end;
end;
///    
///P - , Data - 
procedure DelNode(var P: PNode; Data: TType);
var
  tmp, tmpi: PNode;
begin
  //  ,     
  if P = nil then exit;
  tmp := P;
  
  // 
  if P^.Data = Data then 
  begin
    P := P^.Next;
    Dispose(tmp);
    exit;
  end;
  
  while tmp^.Next <> nil do
    if tmp^.Next^.Data = Data then 
    begin
      tmpi := tmp^.Next;
      tmp^.Next := tmp^.Next^.Next;
      Dispose(tmpi);
      break;
    end
    else tmp := tmp^.Next;
end;
///    
///P -  , Pos -   (   1)
procedure DelNodePos(var P: PNode; Pos: integer);
var
  i: integer;
  tmp, tmpi: PNode;
begin
  if (Pos <= 0) or (P = nil) then  exit;
  tmp := P;
  
  if Pos = 1 then begin P := P^.Next; Dispose(tmp); exit; end;
  
  i := 1;
  while (tmp^.Next <> nil) do
  begin
    Inc(i);
    
    if i = Pos then
    begin
      tmpi := tmp^.Next;
      tmp^.Next := tmpi^.Next;
      Dispose(tmpi); exit;
    end;
    
    tmp := tmp^.next;
  end;
end;

///     
procedure Free(var P: PNode);
var
  P1: PNode;
begin
  while P <> nil do
  begin
    P1 := P;
    P := P^.Next;
    Dispose(P1);
  end;
end;

//-----------------------------------------------
////  ,     
//-----------------------------------------------

///  
procedure Invert(var P: PNode);
var
  Pl, Pr: PNode;
begin
  Pl := nil;
  while P <> nil do
  begin
    Pr := P^.Next;
    P^.Next := Pl;
    Pl := P; P := Pr;
  end;
  P := Pl;
end;

///  ""    
procedure SortBubl(P: PNode);
var
  tmp, rab: PNode;
  tmps: TType;
begin  
  rab := P;
  while rab <> nil do
  begin
    tmp := rab^.next;
    while tmp <> nil do
    begin
      if tmp^.data < rab^.data then
      begin
        //   3 
        tmps := tmp^.data;
        tmp^.data := rab^.data;
        rab^.data := tmps;
      end;
      tmp := tmp^.next;
    end;
    rab := rab^.next;
  end
end;
///  ""    
procedure SortBublLink(P: PNode);
//TODO  .      
{
var
  tmp,pered,pered1,pocle,rab: PNode; //  }
begin{
  rab:=P; //   
  while rab<>nil do//    
  begin
    tmp:=rab^.next; //     
    while tmp<>nil do //    
    begin
      if tmp^.data<rab^.data then //   , 
      begin
        pered:=P; //   
        pered1:=P; //   
        if rab<>P then //      , 
          while pered^.next<>rab do pered:=pered^.next; //    
        while pered1^.next<>tmp do pered1:=pered1^.next; //    ,   
        // 
        pocle:=tmp^.next; //     
        if rab^.next=tmp then //  "", 
        begin
          tmp^.next:=rab; // ,       
          rab^.next:=pocle
        end
        else //     , 
        begin
          tmp^.next:=rab^.next;// ,       
          rab^.next:=pocle;
        end;
        if pered1<>rab then//   
          pered1^.next:=rab;
        if rab<>P then//   
          pered^.next:=tmp
        else//    
          P:=tmp;
        pered1:=tmp;//   
        tmp:=rab;//   
        rab:=pered1;//   
      end;
      tmp:=tmp^.next; //   
    end;
    rab:=rab^.next;//   
  end;
}
end;

///    
procedure ListOut(P: PNode);
begin
  while P <> nil do
  begin
    Write(P^.Data, ' > ');
    P := P^.Next;
  end;
  Writeln('nil');
end;
///    
procedure ListAdOut(P: PNode);
begin
  while P <> nil do
  begin
    Write(P, ' > ');
    P := P^.Next;
  end;
  Writeln('nil');
end;

///      Data
/// ,   ,  - nil
function Search(P: PNode; Data: TType): PNode;
begin
  //TODO  !
  Result := P;
  
  if P = nil then exit;
  if P^.Data = Data then exit;
  
  Result := Search(P^.Next, Data);
end;
///    Ad
/// ,   ,  - nil
function Search(P, Ad: PNode): PNode;
begin
  //TODO  !
  Result := P;
  
  if P = nil then exit;
  if P = Ad then exit;
  
  Result := Search(P^.Next, Ad);
end;
///     Pos
///P -  , Pos -   (1 - )
function GetElem(P: PNode; Pos: integer): PNode;
var
  i: integer;
begin
  if (Pos <= 0) or (P = nil) then  exit;
  
  i := 1;
  while (P^.Next <> nil) do
  begin
    if i = Pos then
    begin
      Result := P;
      exit;
    end;
    Inc(i);
    P := P^.Next;
  end;
end;

///   (nil  )
function GetDepth(P: PNode): integer;
begin
  Result := 0;
  
  while P <> nil do
  begin
    Result += 1;
    P := P^.Next;
  end;
end;

end.